<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-06-28 16:51:03
 * @LastEditors: zwq
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" @keyup.enter.native="dataFormSubmitHandle()" label-width="130px">
    <el-form-item prop="name" :label="$t('code.name')">
      <el-input v-model="dataForm.name" :placeholder="$t('code.name')">
      </el-input>
    </el-form-item>
    <el-form-item prop="code" :label="$t('code.code')">
      <el-input v-model="dataForm.code" :placeholder="$t('code.code')"></el-input>
    </el-form-item>
    <el-form-item prop="eightDisciplineStatus" :label="$t('code.eightDisciplineStatus')">
      <el-switch v-model="dataForm.eightDisciplineStatus" :active-value="1" :inactive-value="0">
      </el-switch>
    </el-form-item>
    <el-form-item prop="eightDisciplineType" :label="$t('code.eightDisciplineType')">
      <el-select v-model="dataForm.eightDisciplineType" :placeholder="$t('code.eightDisciplineType')">
        <el-option v-for="item in eightDisciplineTypeList" :key="item.value" :label="item.label" :value="item.value">
        </el-option>
      </el-select>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/code/eightDiscipline",
        infoURL: "/code/eightDiscipline"
      },
      options: [{
        value: 0,
        label: '不可用'
      },
      {
        value: 1,
        label: '可用'
        }],
      eightDisciplineTypeList: [
        {
          value: '0',
          label: '重复发生问题 '
        },
        {
          value: '1',
          label: '客诉问题'
        },
        {
          value: '2',
          label: '重大质量问题'
        }
      ],
      visible: false,
      dataForm: {
        id: null,
        name: null,
        code:null,	
        eightDisciplineType:null,
        eightDisciplineStatus: 0,
      },
    };
  },
  computed: {
    dataRule() {
      return {
        // dictLabel: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // dictValue: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // sort: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
      };
    },
  },
  methods: {
    init(id, ) {
      this.dataForm.id = id || ""
      // console.log(11111)
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo()
        } else {
          // this.getCode()
        }
      });
    },
    // getCode() {
    //   this.$http.post(this.urlOptions.getCodeURL)
    //     .then(({ data: res }) => {
    //       if (res.code === 0) {
    //         console.log(res);
    //         this.dataForm.customSamplingCode = res.data
    //       }
    //     })
    //     .catch(() => {
    //     });
    // },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/code/eightDiscipline/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
